import java.io.*;
import java.util.*;

public class Main {

  public static void main(String args[]) throws Exception {
    Scanner s = new Scanner(System.in);

    int testCaseNumber = 0;
    while (true) {
        int NC = s.nextInt();//number of connections between network nodes. == ARESTAS
        if (NC == 0) break;        

        Grafo G = new Grafo(30);
        HashMap<String,Integer> id = new HashMap<>(); 

        for (int i = 0; i < NC; i++) {
          String uStr = s.next(); String vStr = s.next();
          Integer u = id.get(uStr); Integer v = id.get(vStr);
          
          if (u == null) {u = id.size(); id.put(uStr, u);}
          if (v == null) { v = id.size(); id.put(vStr, v);}

          G.addEdge(u,v);
        }

        
        while (true) {

          String sStr = s.next();
          int TTL = s.nextInt();

          if (sStr.equals("0") && TTL == 0) break;
          int source = id.get(sStr);


          marked = new boolean[30];
          edgeTo = new int[30];
          distTo = new double[30];

          bfs(G, source);
          testCaseNumber++;

          int QTD = 0;
          for  (int i = 0; i < 30; i++) {
            if (marked[i]) {
              if (distTo[i] > TTL) QTD++;
            }
          }

          /*
          test case number (numbered sequentially from one),
  the number of nodes not reachable, the starting node number, and the initial TTL field setting*/

          System.out.print("Case "+testCaseNumber+": "+ QTD);
          System.out.print(" nodes not reachable from node "+ sStr);
          System.out.print(" with TTL = "+ TTL+".\n");
        }

    }
  }


  static boolean marked[];
  static double distTo[];
  static int edgeTo[];

  static void bfs (Grafo G, int s) {

      Queue<Integer> q = new LinkedList<Integer >() ;

      marked[s] = true ;
      distTo[s] = 0;
      q.add(s) ;

      while ( ! q.isEmpty( ) ) {
        int v = q.remove() ;
        for ( int w : G.adj(v) ) {

        if ( ! marked [ w ] ) {
          edgeTo [w] = v ;
          distTo [w] = distTo [ v ] + 1;
          marked[w] = true ;
          q.add(w) ;
        }

      }

    }
  }
}

class Grafo {

  ArrayList<Integer> adj[];

  public Grafo(int V) {
    adj = new ArrayList[V];
    for (int i =0; i < V; i++) 
      adj[i] = new ArrayList<>();
  }

  void addEdge(int u, int v) {
    adj[u].add(v);
    adj[v].add(u);
  }

  List<Integer> adj(int u) {
    return adj[u];
  }

}


